import { Buff } from '@cmdcode/buff';
import { Event, EventTemplate, Sub } from 'nostr-tools';
import { Client, RoomConfig } from '../schema/types.js';
export declare class NostrRoom {
    readonly cache: Array<[eventName: string, payload: any, envelope: Event]>;
    readonly cipher: Buff;
    readonly client: Client;
    readonly config: RoomConfig;
    readonly events: Record<string, Set<Function>>;
    connected: boolean;
    _sub?: Sub;
    constructor(client: Client, secret: string, config?: Partial<RoomConfig>);
    get members(): string[];
    get id(): Buff;
    _subscribe(): Promise<void>;
    _eventHandler(event: Event): Promise<void>;
    _getFn(eventName: string): Set<Function>;
    emit(eventName: string, ...args: any[]): void;
    pub<T>(eventName: string, payload: T | any, template?: Partial<EventTemplate>): Promise<Event | undefined>;
    on(eventName: string, fn: Function): void;
    once(eventName: string, fn: Function): void;
    within(eventName: string, fn: Function, timeout: number): void;
    remove(eventName: string, fn: Function): void;
    prune(eventName: string): void;
    leave(): void;
}
//# sourceMappingURL=room.d.ts.map